Index: /trunk/source/Lib/TLibEncoder/TEncGOP.cpp
===================================================================
--- /trunk/source/Lib/TLibEncoder/TEncGOP.cpp	(revision 1355)
+++ /trunk/source/Lib/TLibEncoder/TEncGOP.cpp	(revision 1356)
@@ -100,7 +100,7 @@
   m_layerId      = 0;
   m_viewId       = 0;
-  m_pocLastCoded = -1; 
+  m_pocLastCoded = -1;
 #if NH_3D
-  m_viewIndex  =   0; 
+  m_viewIndex  =   0;
   m_isDepth = false;
 #endif
@@ -147,5 +147,5 @@
 
 #if NH_MV
-  m_ivPicLists           = pcTEncTop->getIvPicLists(); 
+  m_ivPicLists           = pcTEncTop->getIvPicLists();
   m_layerId              = pcTEncTop->getLayerId();
   m_viewId               = pcTEncTop->getViewId();
@@ -156,6 +156,6 @@
 #endif
 #if NH_3D_IC
-  m_aICEnableCandidate   = pcTEncTop->getICEnableCandidate(); 
-  m_aICEnableNum         = pcTEncTop->getICEnableNum(); 
+  m_aICEnableCandidate   = pcTEncTop->getICEnableCandidate();
+  m_aICEnableNum         = pcTEncTop->getICEnableNum();
 #endif
 #if KWU_FIX_URQ
@@ -207,5 +207,5 @@
 #if NH_MV
   if ( getLayerId() == 0 )
-  {  
+  {
     actualTotalBits += xWriteVPS(accessUnit, m_pcEncTop->getVPS());
   }
@@ -277,5 +277,5 @@
 
   while ( (itNalu!=accessUnit.end())&&
-    ( (*itNalu)->m_nalUnitType==NAL_UNIT_ACCESS_UNIT_DELIMITER 
+    ( (*itNalu)->m_nalUnitType==NAL_UNIT_ACCESS_UNIT_DELIMITER
     || (*itNalu)->m_nalUnitType==NAL_UNIT_VPS
     || (*itNalu)->m_nalUnitType==NAL_UNIT_SPS
@@ -288,5 +288,5 @@
   SEIMessages localMessages = seiMessages;
   SEIMessages currentMessages;
-  
+
 #if ENC_DEC_TRACE
   g_HLSTraceEnable = !testWrite;
@@ -299,5 +299,5 @@
   xWriteSEI(NAL_UNIT_PREFIX_SEI, currentMessages, accessUnit, itNalu, temporalId, sps);
   xClearSEIs(currentMessages, !testWrite);
-  
+
   // Buffering period SEI must always be following active parameter sets
   currentMessages = extractSeisByType(localMessages, SEI::BUFFERING_PERIOD);
@@ -328,4 +328,11 @@
   xWriteSEISeparately(NAL_UNIT_PREFIX_SEI, currentMessages, accessUnit, itNalu, temporalId, sps);
   xClearSEIs(currentMessages, !testWrite);
+
+#if NH_MV_LAYERS_NOT_PRESENT_SEI
+  // Layers not present SEI message
+  currentMessages = extractSeisByType(localMessages, SEI::LAYERS_NOT_PRESENT);
+  xWriteSEISeparately(NAL_UNIT_PREFIX_SEI, currentMessages, accessUnit, itNalu, temporalId, sps);
+  xClearSEIs(currentMessages, !testWrite);
+#endif
 
   // And finally everything else one by one
@@ -412,9 +419,6 @@
 Void TEncGOP::xCreateIRAPLeadingSEIMessages (SEIMessages& seiMessages, const TComSPS *sps, const TComPPS *pps)
 {
-#if NH_MV
-  OutputNALUnit nalu(NAL_UNIT_PREFIX_SEI, 0, getLayerId());
-#else
   OutputNALUnit nalu(NAL_UNIT_PREFIX_SEI);
-#endif
+
   if(m_pcCfg->getActiveParameterSetsSEIEnabled())
   {
@@ -472,5 +476,5 @@
     seiMessages.push_back(sei);
   }
-    
+
   if(m_pcCfg->getMasteringDisplaySEI().colourVolumeSEIEnabled)
   {
@@ -482,10 +486,12 @@
 
 #if NH_MV
+#if !NH_MV_SEI
   if( m_pcCfg->getSubBitstreamPropSEIEnabled() && ( getLayerId() == 0 ) )
   {
     SEISubBitstreamProperty *sei = new SEISubBitstreamProperty;
-    m_seiEncoder.initSEISubBitstreamProperty( sei, sps );   
+    m_seiEncoder.initSEISubBitstreamProperty( sei, sps );
     seiMessages.push_back(sei);
   }
+#endif
 #endif
 }
@@ -679,5 +685,5 @@
       }
     }
-    
+
     if( m_pcCfg->getPictureTimingSEIEnabled() )
     {
@@ -715,5 +721,5 @@
     return;
   }
-  // fix first 
+  // fix first
   UInt numNalUnits = (UInt)testAU.size();
   UInt numRBSPBytes = 0;
@@ -927,5 +933,5 @@
           IRAPGOPid = iGOPid;
           IRAPtoReorder = true;
-          swapIRAPForward = true; 
+          swapIRAPForward = true;
           break;
         }
@@ -935,5 +941,5 @@
           IRAPGOPid = iGOPid;
           IRAPtoReorder = true;
-          swapIRAPForward = false; 
+          swapIRAPForward = false;
           break;
         }
@@ -1066,6 +1072,6 @@
 #endif
 #if NH_MV
-Void TEncGOP::compressPicInGOP( Int iPOCLast, Int iNumPicRcvd, TComList<TComPic*>& rcListPic, 
-                                TComList<TComPicYuv*>& rcListPicYuvRecOut,  std::list<AccessUnit>& accessUnitsInGOP, 
+Void TEncGOP::compressPicInGOP( Int iPOCLast, Int iNumPicRcvd, TComList<TComPic*>& rcListPic,
+                                TComList<TComPicYuv*>& rcListPicYuvRecOut,  std::list<AccessUnit>& accessUnitsInGOP,
                                 Bool isField, Bool isTff, const InputColourSpaceConversion snr_conversion, const Bool printFrameMSE, Int iGOPid )
 #else
@@ -1170,5 +1176,5 @@
     pcPic->setCurrSliceIdx(0);
 #if NH_MV
-    m_pcSliceEncoder->initEncSlice ( pcPic, iPOCLast, pocCurr, iGOPid, pcSlice, m_pcEncTop->getVPS(), getLayerId(), isField  );     
+    m_pcSliceEncoder->initEncSlice ( pcPic, iPOCLast, pocCurr, iGOPid, pcSlice, m_pcEncTop->getVPS(), getLayerId(), isField  );
 #else
     m_pcSliceEncoder->initEncSlice ( pcPic, iPOCLast, pocCurr, iGOPid, pcSlice, isField );
@@ -1181,17 +1187,17 @@
     pcSlice->setSliceIdx(0);
 #if NH_MV
-    pcSlice->setRefPicSetInterLayer ( &m_refPicSetInterLayer0, &m_refPicSetInterLayer1 ); 
+    pcSlice->setRefPicSetInterLayer ( &m_refPicSetInterLayer0, &m_refPicSetInterLayer1 );
     pcPic  ->setLayerId     ( getLayerId()   );
-    pcPic  ->setViewId      ( getViewId()    );    
+    pcPic  ->setViewId      ( getViewId()    );
 #if !NH_3D
     pcSlice->setLayerId     ( getLayerId() );
-    pcSlice->setViewId      ( getViewId()  );    
+    pcSlice->setViewId      ( getViewId()  );
     pcSlice->setVPS         ( m_pcEncTop->getVPS() );
 #else
-    pcPic  ->setViewIndex   ( getViewIndex() ); 
+    pcPic  ->setViewIndex   ( getViewIndex() );
     pcPic  ->setIsDepth( getIsDepth() );
-    pcSlice->setCamparaSlice( pcPic->getCodedScale(), pcPic->getCodedOffset() );    
-#endif
-#endif 
+    pcSlice->setCamparaSlice( pcPic->getCodedScale(), pcPic->getCodedOffset() );
+#endif
+#endif
     //set default slice level flag to the same as SPS level flag
     pcSlice->setLFCrossSliceBoundaryFlag(  pcSlice->getPPS()->getLoopFilterAcrossSlicesEnabledFlag()  );
@@ -1201,6 +1207,6 @@
     if( pcSlice->getSliceType() == B_SLICE )
     {
-      if( m_pcCfg->getGOPEntry( ( pcSlice->getRapPicFlag() && getLayerId() > 0 ) ? MAX_GOP : iGOPid ).m_sliceType == 'P' ) 
-      { 
+      if( m_pcCfg->getGOPEntry( ( pcSlice->getRapPicFlag() && getLayerId() > 0 ) ? MAX_GOP : iGOPid ).m_sliceType == 'P' )
+      {
         pcSlice->setSliceType( P_SLICE );
       }
@@ -1210,6 +1216,6 @@
     if( pcSlice->getSliceType() == B_SLICE )
     {
-      if( m_pcCfg->getGOPEntry( ( pcSlice->getRapPicFlag() && getLayerId() > 0 ) ? MAX_GOP : iGOPid ).m_sliceType == 'I' ) 
-      { 
+      if( m_pcCfg->getGOPEntry( ( pcSlice->getRapPicFlag() && getLayerId() > 0 ) ? MAX_GOP : iGOPid ).m_sliceType == 'I' )
+      {
         pcSlice->setSliceType( I_SLICE );
       }
@@ -1225,5 +1231,5 @@
       pcSlice->setSliceType(I_SLICE);
     }
-    
+
     // Set the nal unit type
     pcSlice->setNalUnitType(getNalUnitType(pocCurr, m_iLastIDR, isField));
@@ -1279,5 +1285,5 @@
     pcSlice->setAssociatedIRAPPOC(m_associatedIRAPPOC);
     }
-    if ((pcSlice->checkThatAllRefPicsAreAvailable(rcListPic, pcSlice->getRPS(), false, m_iLastRecoveryPicPOC, m_pcCfg->getDecodingRefreshType() == 3) != 0) || (pcSlice->isIRAP()) 
+    if ((pcSlice->checkThatAllRefPicsAreAvailable(rcListPic, pcSlice->getRPS(), false, m_iLastRecoveryPicPOC, m_pcCfg->getDecodingRefreshType() == 3) != 0) || (pcSlice->isIRAP())
       || (m_pcCfg->getEfficientFieldIRAPEnabled() && isField && pcSlice->getAssociatedIRAPType() >= NAL_UNIT_CODED_SLICE_BLA_W_LP && pcSlice->getAssociatedIRAPType() <= NAL_UNIT_CODED_SLICE_CRA && pcSlice->getAssociatedIRAPPOC() == pcSlice->getPOC()+1)
       )
@@ -1288,5 +1294,5 @@
     pcSlice->applyReferencePictureSet(rcListPic, pcSlice->getRPS());
 
-    if(pcSlice->getTLayer() > 0 
+    if(pcSlice->getTLayer() > 0
       &&  !( pcSlice->getNalUnitType() == NAL_UNIT_CODED_SLICE_RADL_N     // Check if not a leading picture
           || pcSlice->getNalUnitType() == NAL_UNIT_CODED_SLICE_RADL_R
@@ -1358,34 +1364,34 @@
     if ( pcSlice->getPPS()->getNumExtraSliceHeaderBits() > 0 )
     {
-      // Some more sophisticated algorithm to determine discardable_flag might be added here. 
-      pcSlice->setDiscardableFlag           ( false );     
-    }    
-
-    const TComVPS*           vps = pcSlice->getVPS();     
+      // Some more sophisticated algorithm to determine discardable_flag might be added here.
+      pcSlice->setDiscardableFlag           ( false );
+    }
+
+    const TComVPS*           vps = pcSlice->getVPS();
 #if NH_3D
-    Int numDirectRefLayers = vps    ->getNumRefListLayers( getLayerId() ); 
+    Int numDirectRefLayers = vps    ->getNumRefListLayers( getLayerId() );
 #else
-    Int numDirectRefLayers = vps    ->getNumDirectRefLayers( getLayerId() ); 
+    Int numDirectRefLayers = vps    ->getNumDirectRefLayers( getLayerId() );
 #endif
 #if NH_3D
-    pcSlice->setIvPicLists( m_ivPicLists );         
+    pcSlice->setIvPicLists( m_ivPicLists );
 
     Int gopNum = (pcSlice->getRapPicFlag() && getLayerId() > 0) ? MAX_GOP : iGOPid;
-    GOPEntry gopEntry      = m_pcCfg->getGOPEntry( gopNum );     
+    GOPEntry gopEntry      = m_pcCfg->getGOPEntry( gopNum );
 #else
-    GOPEntry gopEntry      = m_pcCfg->getGOPEntry( (pcSlice->getRapPicFlag() && getLayerId() > 0) ? MAX_GOP : iGOPid );     
-#endif
-
-
-    
-    Bool interLayerPredLayerIdcPresentFlag = false; 
+    GOPEntry gopEntry      = m_pcCfg->getGOPEntry( (pcSlice->getRapPicFlag() && getLayerId() > 0) ? MAX_GOP : iGOPid );
+#endif
+
+
+
+    Bool interLayerPredLayerIdcPresentFlag = false;
     if ( getLayerId() > 0 && !vps->getAllRefLayersActiveFlag() && numDirectRefLayers > 0 )
-    {         
-      pcSlice->setInterLayerPredEnabledFlag ( gopEntry.m_numActiveRefLayerPics > 0 );     
+    {
+      pcSlice->setInterLayerPredEnabledFlag ( gopEntry.m_numActiveRefLayerPics > 0 );
       if ( pcSlice->getInterLayerPredEnabledFlag() && numDirectRefLayers > 1 )
       {
         if ( !vps->getMaxOneActiveRefLayerFlag() )
-        {    
-          pcSlice->setNumInterLayerRefPicsMinus1( gopEntry.m_numActiveRefLayerPics - 1 ); 
+        {
+          pcSlice->setNumInterLayerRefPicsMinus1( gopEntry.m_numActiveRefLayerPics - 1 );
         }
 #if NH_3D
@@ -1394,9 +1400,9 @@
         if ( gopEntry.m_numActiveRefLayerPics != vps->getNumDirectRefLayers( getLayerId() ) )
 #endif
-        {        
-          interLayerPredLayerIdcPresentFlag = true; 
+        {
+          interLayerPredLayerIdcPresentFlag = true;
           for (Int i = 0; i < gopEntry.m_numActiveRefLayerPics; i++ )
           {
-            pcSlice->setInterLayerPredLayerIdc( i, gopEntry.m_interLayerPredLayerIdc[ i ] ); 
+            pcSlice->setInterLayerPredLayerIdc( i, gopEntry.m_interLayerPredLayerIdc[ i ] );
           }
         }
@@ -1405,5 +1411,5 @@
     if ( !interLayerPredLayerIdcPresentFlag )
     {
-      for( Int i = 0; i < pcSlice->getNumActiveRefLayerPics(); i++ )   
+      for( Int i = 0; i < pcSlice->getNumActiveRefLayerPics(); i++ )
       {
         pcSlice->setInterLayerPredLayerIdc(i, pcSlice->getRefLayerPicIdc( i ) );
@@ -1412,13 +1418,13 @@
 
 
-    assert( pcSlice->getNumActiveRefLayerPics() == gopEntry.m_numActiveRefLayerPics ); 
-    
+    assert( pcSlice->getNumActiveRefLayerPics() == gopEntry.m_numActiveRefLayerPics );
+
 #if NH_3D
     if ( m_pcEncTop->decProcAnnexI() )
-    {    
-      pcSlice->deriveInCmpPredAndCpAvailFlag( ); 
+    {
+      pcSlice->deriveInCmpPredAndCpAvailFlag( );
       if ( pcSlice->getInCmpPredAvailFlag() )
-      {      
-        pcSlice->setInCompPredFlag( gopEntry.m_interCompPredFlag ); 
+      {
+        pcSlice->setInCompPredFlag( gopEntry.m_interCompPredFlag );
       }
       else
@@ -1434,11 +1440,11 @@
             printf( "\nError: Frame%d_l%d cannot enable inter-component prediction on slice level. All reference layers need to be available and at least one tool using inter-component prediction must be enabled in the SPS. \n", gopNum, pcSlice->getVPS()->getLayerIdInVps( getLayerId() ) );
           }
-          
+
           exit(EXIT_FAILURE);
         }
       }
-      pcSlice->init3dToolParameters(); 
-      pcSlice->checkInCompPredRefLayers(); 
-    }   
+      pcSlice->init3dToolParameters();
+      pcSlice->checkInCompPredRefLayers();
+    }
 #if NH_3D_IV_MERGE
     // This needs to be done after initialization of 3D tool parameters.
@@ -1447,5 +1453,5 @@
 #endif
 
-    pcSlice->createInterLayerReferencePictureSet( m_ivPicLists, m_refPicSetInterLayer0, m_refPicSetInterLayer1 ); 
+    pcSlice->createInterLayerReferencePictureSet( m_ivPicLists, m_refPicSetInterLayer0, m_refPicSetInterLayer1 );
     pcSlice->setNumRefIdx(REF_PIC_LIST_0,min(gopEntry.m_numRefPicsActive,( pcSlice->getRPS()->getNumberOfPictures() + (Int) m_refPicSetInterLayer0.size() + (Int) m_refPicSetInterLayer1.size()) ) );
     pcSlice->setNumRefIdx(REF_PIC_LIST_1,min(gopEntry.m_numRefPicsActive,( pcSlice->getRPS()->getNumberOfPictures() + (Int) m_refPicSetInterLayer0.size() + (Int) m_refPicSetInterLayer1.size()) ) );
@@ -1456,7 +1462,7 @@
 
     pcSlice->getTempRefPicLists( rcListPic, m_refPicSetInterLayer0, m_refPicSetInterLayer1, tempRefPicLists, usedAsLongTerm, numPocTotalCurr, true );
-    
-
-    xSetRefPicListModificationsMv( tempRefPicLists, pcSlice, iGOPid );    
+
+
+    xSetRefPicListModificationsMv( tempRefPicLists, pcSlice, iGOPid );
 #else
     pcSlice->setNumRefIdx(REF_PIC_LIST_0,min(m_pcCfg->getGOPEntry(iGOPid).m_numRefPicsActive,pcSlice->getRPS()->getNumberOfPictures()));
@@ -1464,6 +1470,6 @@
 #endif
     //  Set reference list
-#if NH_MV    
-    pcSlice->setRefPicList( tempRefPicLists, usedAsLongTerm, numPocTotalCurr ); 
+#if NH_MV
+    pcSlice->setRefPicList( tempRefPicLists, usedAsLongTerm, numPocTotalCurr );
 #else
     pcSlice->setRefPicList ( rcListPic );
@@ -1477,6 +1483,6 @@
 #endif
 #if NH_3D_IC
-    pcSlice->setICEnableCandidate( m_aICEnableCandidate );         
-    pcSlice->setICEnableNum( m_aICEnableNum );         
+    pcSlice->setICEnableCandidate( m_aICEnableCandidate );
+    pcSlice->setICEnableNum( m_aICEnableNum );
 #endif
 
@@ -1485,7 +1491,7 @@
     if ( pcSlice->getSliceType() == B_SLICE )
     {
-      if( m_pcCfg->getGOPEntry( ( pcSlice->getRapPicFlag() == true && getLayerId() > 0 ) ? MAX_GOP : iGOPid ).m_sliceType == 'P' ) 
-      { 
-        pcSlice->setSliceType( P_SLICE ); 
+      if( m_pcCfg->getGOPEntry( ( pcSlice->getRapPicFlag() == true && getLayerId() > 0 ) ? MAX_GOP : iGOPid ).m_sliceType == 'P' )
+      {
+        pcSlice->setSliceType( P_SLICE );
       }
     }
@@ -1566,8 +1572,8 @@
 
 #if NH_3D_VSO
-  // Should be moved to TEncTop !!! 
+  // Should be moved to TEncTop !!!
   Bool bUseVSO = m_pcEncTop->getUseVSO();
-  
-  TComRdCost* pcRdCost = m_pcEncTop->getRdCost();   
+
+  TComRdCost* pcRdCost = m_pcEncTop->getRdCost();
 
   pcRdCost->setUseVSO( bUseVSO );
@@ -1725,5 +1731,5 @@
 #endif
 #if NH_3D
-      pcSlice->setDepthToDisparityLUTs(); 
+      pcSlice->setDepthToDisparityLUTs();
 
 #endif
@@ -1835,4 +1841,8 @@
     xCreatePerPictureSEIMessages(iGOPid, leadingSeiMessages, nestedSeiMessages, pcSlice);
 
+#if NH_MV_SEI
+    m_seiEncoder.createAnnexFGISeiMessages( leadingSeiMessages, pcSlice );
+#endif
+
     /* use the main bitstream buffer for storing the marshalled picture */
     m_pcEntropyCoder->setBitstream(NULL);
@@ -1980,5 +1990,5 @@
     cabac_zero_word_padding(pcSlice, pcPic, binCountsInNalUnits, numBytesInVclNalUnits, accessUnit.back()->m_nalUnitData, m_pcCfg->getCabacZeroWordPaddingEnabled());
 #if NH_3D
-      pcPic->compressMotion(2); 
+      pcPic->compressMotion(2);
 #else
     pcPic->compressMotion();
@@ -2055,7 +2065,7 @@
     pcPic->setReconMark   ( true );
 #if NH_MV
-      TComSlice::markIvRefPicsAsShortTerm( m_refPicSetInterLayer0, m_refPicSetInterLayer1 );  
-      std::vector<Int> temp; 
-      TComSlice::markCurrPic( pcPic ); 
+      TComSlice::markIvRefPicsAsShortTerm( m_refPicSetInterLayer0, m_refPicSetInterLayer1 );
+      std::vector<Int> temp;
+      TComSlice::markCurrPic( pcPic );
 #endif
     m_bFirst = false;
@@ -2094,5 +2104,5 @@
   //-- all
 #if NH_MV
-  printf( "\n\nSUMMARY -------------------------------------------- LayerId %2d\n", getLayerId() );   
+  printf( "\n\nSUMMARY -------------------------------------------- LayerId %2d\n", getLayerId() );
 #else
   printf( "\n\nSUMMARY --------------------------------------------------------\n" );
@@ -2402,6 +2412,6 @@
 #if H_3D_VSO_SYNTH_DIST_OUT
 }
-#endif 
-#endif  
+#endif
+#endif
   /* calculate the size of the access unit, excluding:
    *  - any AnnexB contributions (start_code_prefix, zero_byte, etc.,)
@@ -2526,5 +2536,5 @@
 
 #if  NH_MV
-  assert( 0 ); // Field coding and MV need to be aligned. 
+  assert( 0 ); // Field coding and MV need to be aligned.
 #else
 
@@ -2969,21 +2979,21 @@
 #if NH_MV
 Void TEncGOP::xSetRefPicListModificationsMv( std::vector<TComPic*> tempPicLists[2], TComSlice* pcSlice, UInt iGOPid )
-{ 
-  
+{
+
   if( pcSlice->getSliceType() == I_SLICE || !(pcSlice->getPPS()->getListsModificationPresentFlag()) || pcSlice->getNumActiveRefLayerPics() == 0 )
   {
     return;
   }
-  
+
   GOPEntry ge = m_pcCfg->getGOPEntry( (pcSlice->getRapPicFlag() && ( pcSlice->getLayerId( ) > 0) ) ? MAX_GOP : iGOPid );
-  assert( ge.m_numActiveRefLayerPics == pcSlice->getNumActiveRefLayerPics() ); 
-
-  Int numPicsInTempList     = pcSlice->getNumRpsCurrTempList();  
-
-  // GT: check if SliceType should be checked here. 
+  assert( ge.m_numActiveRefLayerPics == pcSlice->getNumActiveRefLayerPics() );
+
+  Int numPicsInTempList     = pcSlice->getNumRpsCurrTempList();
+
+  // GT: check if SliceType should be checked here.
   for (Int li = 0; li < 2; li ++) // Loop over lists L0 and L1
   {
-    Int numPicsInFinalRefList = pcSlice->getNumRefIdx( ( li == 0 ) ? REF_PIC_LIST_0 : REF_PIC_LIST_1 ); 
-            
+    Int numPicsInFinalRefList = pcSlice->getNumRefIdx( ( li == 0 ) ? REF_PIC_LIST_0 : REF_PIC_LIST_1 );
+
     Int finalIdxToTempIdxMap[16];
     for( Int k = 0; k < 16; k++ )
@@ -2999,38 +3009,38 @@
         // get position in temp. list
         Int refPicLayerId = pcSlice->getRefPicLayerId(k);
-        Int idxInTempList = 0; 
+        Int idxInTempList = 0;
         for (; idxInTempList < numPicsInTempList; idxInTempList++)
         {
           if ( (tempPicLists[li][idxInTempList])->getLayerId() == refPicLayerId )
           {
-            break; 
+            break;
           }
         }
 
         Int idxInFinalList = ge.m_interViewRefPosL[ li ][ k ];
-        
-        // Add negative from behind 
-        idxInFinalList = ( idxInFinalList < 0 )? ( numPicsInTempList + idxInFinalList ) : idxInFinalList; 
-        
+
+        // Add negative from behind
+        idxInFinalList = ( idxInFinalList < 0 )? ( numPicsInTempList + idxInFinalList ) : idxInFinalList;
+
         Bool curIsModified = ( idxInFinalList != idxInTempList ) && ( ( idxInTempList < numPicsInFinalRefList ) || ( idxInFinalList < numPicsInFinalRefList ) ) ;
         if ( curIsModified )
         {
-          isModified = true; 
+          isModified = true;
           assert( finalIdxToTempIdxMap[ idxInFinalList ] == -1 ); // Assert when two inter layer reference pictures are sorted to the same position
         }
-        finalIdxToTempIdxMap[ idxInFinalList ] = idxInTempList;              
+        finalIdxToTempIdxMap[ idxInFinalList ] = idxInTempList;
       }
     }
 
     TComRefPicListModification* refPicListModification = pcSlice->getRefPicListModification();
-    refPicListModification->setRefPicListModificationFlagL( li, isModified );  
+    refPicListModification->setRefPicListModificationFlagL( li, isModified );
 
     if( isModified )
     {
       Int refIdx = 0;
-      
+
       for( Int i = 0; i < numPicsInFinalRefList; i++ )
       {
-        if( finalIdxToTempIdxMap[i] >= 0 ) 
+        if( finalIdxToTempIdxMap[i] >= 0 )
         {
           refPicListModification->setRefPicSetIdxL( li, i, finalIdxToTempIdxMap[i] );
@@ -3042,5 +3052,5 @@
           while( ( refIdx < numPicsInTempList ) && ( tempPicLists[li][refIdx]->getLayerId() != getLayerId())  )
           {
-            refIdx++; 
+            refIdx++;
           }
           refPicListModification->setRefPicSetIdxL( li, i, refIdx );
Index: /trunk/source/Lib/TLibRenderer/TRenModSetupStrParser.h
===================================================================
--- /trunk/source/Lib/TLibRenderer/TRenModSetupStrParser.h	(revision 1355)
+++ /trunk/source/Lib/TLibRenderer/TRenModSetupStrParser.h	(revision 1356)
@@ -87,6 +87,6 @@
                                 );
 
-  std::vector<Int>* getSynthViews() { return &m_aiAllSynthViewNums;  }
-  std::vector<Int>* getBaseViews()  { return &m_aiAllBaseViewIdx;    }
+  IntAry1d*  getSynthViews() { return &m_aiAllSynthViewNums;  }
+  IntAry1d*  getBaseViews()  { return &m_aiAllBaseViewIdx;    }
 
   TRenModSetupStrParser();
@@ -95,15 +95,15 @@
 
 private:
-  std::vector< std::vector<Int > > m_aaaiBaseViewsIdx  [2];
-  std::vector< std::vector<Int > > m_aaaiVideoDistMode [2];
-  std::vector< std::vector<Int > > m_aaaiDepthDistMode [2];
-  std::vector< std::vector<Int > > m_aaaiModelNums     [2];
-  std::vector< std::vector<Int > > m_aaaiSynthViewNums [2];
-  std::vector< std::vector<Bool> > m_aaabOrgRef        [2];
-  std::vector< std::vector<Bool> > m_aaabExtrapolate   [2];
-  std::vector< std::vector<Int > > m_aaaiBlendMode     [2];
+  IntAry2d                         m_aaaiBaseViewsIdx  [2];
+  IntAry2d                         m_aaaiVideoDistMode [2];
+  IntAry2d                         m_aaaiDepthDistMode [2];
+  IntAry2d                         m_aaaiModelNums     [2];
+  IntAry2d                         m_aaaiSynthViewNums [2];
+  BoolAry2d                        m_aaabOrgRef        [2];
+  BoolAry2d                        m_aaabExtrapolate   [2];
+  IntAry2d                         m_aaaiBlendMode     [2];
 
-  std::vector<Int>                 m_aiAllBaseViewIdx;
-  std::vector<Int>                 m_aiAllSynthViewNums;
+  IntAry1d                         m_aiAllBaseViewIdx;
+  IntAry1d                         m_aiAllSynthViewNums;
 
   Bool                             m_bCurrentViewSet;
